<template>
    <div class="container">
        <StudyCreationModal v-if="new_study_modal_open" @close-modal="new_study_modal_open = false" @create-study="createNewStudy" :loading="study_being_created"/>
        <StudyDataModal v-if="study_data_modal_open == StudyModalStatus.Edit && study_edit" @close-modal="study_data_modal_open = StudyModalStatus.Closed" :study_data="study_edit" @refresh-studies="getStudyList" 
            @manage-experimental-data="toggleExpModal(StudyModalStatus.Edit)"/>
        <StudyDataModalPublic v-if="study_data_modal_open == StudyModalStatus.View && study_edit" @close-modal="study_data_modal_open = StudyModalStatus.Closed" :study_data="study_edit" 
            @refresh-studies="getStudyList" @manage-experimental-data="toggleExpModal(StudyModalStatus.View)"/>
        <StudyExpDataModal v-if="study_data_exp_modal_open != StudyModalStatus.Closed && study_edit" @close-modal="study_data_exp_modal_open = StudyModalStatus.Closed" :study_data="study_edit"
            :edit_status="study_data_exp_modal_open" @back-to-study="toggleExpModal(study_data_exp_modal_open)"/>
        <div class="hmdb-info" v-if="studies.hmdb_enforced">This MetaboSERV instance <b>does enforce HMDB identifiers</b> for all metabolites. You can map metabolite names to HMDB accession numbers <router-link to="/map">here</router-link>.</div>
        <div v-if="studies.studies_owned && studies.studies_owned.length >= 1" class="study_separator">
            <div class="study-headline">Your studies:</div>
            <div class="study-collection" id="studies-owned">
                <StudyBox v-for="study of studies.studies_owned" :key="study.study_id" :data="study" :status="'owned'" @click="openModal(study)"/>
                <div class="new-study-container">
                    <div class="new-study" @click="new_study_modal_open = true">+</div>
                </div>
            </div>
        </div>
        <div v-if="studies.studies_owned && Object.keys(studies.studies_owned).length < 1 && !auth.jwt" class="study_separator">
            <div class="study-headline">Your studies:</div>
            <div style="text-align: center; margin-bottom: 4rem;">There is nothing to see here yet! Please create a user account/log in to create your own studies.</div>
        </div>
        
        <div v-if="studies.studies_shared && studies.studies_shared.length >= 1" class="study_separator">
            <div class="study-headline">Shared studies:</div>
            <div class="study-collection" id="studies-shared">
                <StudyBox v-for="study of studies.studies_shared" :key="study.study_id" :data="study" :status="'shared'" @click="openModal(study)"/>
            </div>
        </div>

        <div v-if="studies.studies_public && studies.studies_public.length >= 1" class="study_separator">
            <div class="study-headline">Public studies:</div>
            <div class="study-collection" id="studies-public">
                <StudyBox v-for="study of studies.studies_public" :key="study.study_id" :data="study" status="'public'" @click="openModal(study)"/>
            </div>
        </div>
        <div v-if="studies.studies_owned && Object.keys(studies.studies_owned).length < 1 && auth.jwt" class="study_separator">
            <div class="study-headline">You don't seem to have any studies yet! Click the plus to create one:</div>
            <div class="study-collection" id="studies-owned">
                    <div class="new-study-container">
                        <div class="new-study" @click="new_study_modal_open = true">+</div>
                    </div>
            </div>
        </div>
    </div>
    
</template>

<script setup lang="ts">
import { useStudyStore, type StudyData, type StudyFiles, StudyModalStatus } from '@/stores/studies';
import { useAuthStore } from '@/stores/auth';
import { onMounted, ref, watch } from 'vue';
import { getStudyList, createStudy, type ParseParameters } from '@/modules/study_module';
import StudyBox from "@/components/study/StudyBox.vue";
import StudyCreationModal from "@/components/study/StudyCreationModal.vue";
import StudyDataModal from '@/components/study/StudyDataModal.vue';
import StudyDataModalPublic from '@/components/study/StudyDataModalPublic.vue';
import StudyExpDataModal from '@/components/study/StudyExpDataModal.vue';
import { useMessageStore } from '@/stores/message';
import { areHMDBIdentifiersEnforced } from '@/modules/query_module';

const studies = useStudyStore();
const auth = useAuthStore();
const msg = useMessageStore();

onMounted(async () => {
    await getStudyList();
    if (studies.hmdb_enforced === null) {
        let enforced = await areHMDBIdentifiersEnforced();
        studies.hmdb_enforced = enforced.body as boolean;
    }
});


    

const createNewStudy = async (study_payload: StudyData, study_files: StudyFiles, parse_parameters: ParseParameters) => {
    study_being_created.value = true;
    await createStudy(study_payload, study_files, parse_parameters).then(async (res) => {
        if (res.status < 200 || res.status > 299) {
            msg.add_message({status: res.status, msg: res.msg});
        } else {
            msg.add_message({status: res.status, msg: res.msg});
            await getStudyList();
            new_study_modal_open.value = false;
        }
    });
    study_being_created.value = false;
}

const toggleExpModal = (t: StudyModalStatus) => {
    study_data_modal_open.value = (study_data_modal_open.value == StudyModalStatus.Closed ? t : StudyModalStatus.Closed);
    study_data_exp_modal_open.value = (study_data_exp_modal_open.value == StudyModalStatus.Closed ? t : StudyModalStatus.Closed);
    msg.close_all();
}

const openModal = (study: StudyData) => {
    if (!Object.keys(study.study_members).includes(auth.username) || study.study_members[auth.username as keyof typeof study.study_members] == "viewer")  {
        study_data_modal_open.value = StudyModalStatus.View;
    } else {
        study_data_modal_open.value = StudyModalStatus.Edit;
    };
    study_edit.value = study;
    msg.close_all();
}


watch(() => auth.jwt, async () => {
    new_study_modal_open.value = false;
    study_data_modal_open.value = StudyModalStatus.Closed;
    study_data_exp_modal_open.value = StudyModalStatus.Closed;
    await getStudyList();
});
watch(() => studies.studies_owned, () => {
    if (!study_edit.value || !studies.studies_owned) return;
    let study_filter = studies.studies_owned.filter((st) => st.study_id == study_edit?.value?.study_id);
    if (!study_filter.length) return;
    study_edit.value = study_filter[0];
});
watch(() => studies.studies_shared, () => {
    if (!study_edit.value || !studies.studies_shared) return;
    let study_filter = studies.studies_shared.filter((st) => st.study_id == study_edit?.value?.study_id);
    if (!study_filter.length) return;
    study_edit.value = study_filter[0];
});



const new_study_modal_open = ref<boolean>(false);
const study_data_modal_open = ref<StudyModalStatus>(StudyModalStatus.Closed);
const study_data_exp_modal_open = ref<StudyModalStatus>(StudyModalStatus.Closed);
const study_edit = ref<StudyData>();
const study_being_created = ref<boolean>(false);
</script>

<style scoped>

.hmdb-info {
    font-size: var(--fs-small);
    text-align: center;
}

.hmdb-info a, a:active {
    color: var(--color-primary);
}

.hmdb-info a:hover {
    color: var(--color-head);
}

.study-headline {
  color: var(--color-head);
  font-size: var(--fs-title);
  text-align: center;
  padding-top: 0.5rem;
}
.container {
    max-width: 100%;
    color: #000;
    background: #fff;
}

.study_separator:nth-child(2) {
    background-color: var(--color-bg);
}


.study-collection {
    max-width: 84rem;
    display: grid;
    align-items: center;
    justify-items: center;
    justify-content: center;
    grid-template-columns: repeat(3, 20rem);
    gap: 1rem;
    margin: auto;
    padding-bottom: 1rem;
    margin-bottom: 1rem;
}

.new-study-container {
    width: 20rem;
    height: 12rem;
    display: flex;
    align-items: center;
    justify-content: center;
}

.new-study {
    width: 6rem;
    height: 6rem;
    border: 8px solid var(--color-head);
    border-radius: 10px;
    display: flex;
    align-items: center;
    justify-content: center;
    font-size: 5rem;
    color: var(--color-head);
    cursor: pointer;
}

.new-study:hover {
    scale: 1.1 1.1;
}

@media (max-width: 1600px) {
    .study-collection {
        grid-template-columns: repeat(3, 20rem);
    }
}

@media (max-width: 1200px) {
    .study-collection {
        grid-template-columns: repeat(2, 20rem);
    }
}

@media (max-width: 800px) {
    .study-collection {
        grid-template-columns: repeat(1, 20rem);
    }
}

</style>